// gcc -o trsm.x -Wall -L/Users/pauldj/works-G/libsG/OpenBLAS/ -lopenblas my-trsm.c


#include <stdlib.h>   // always necessary
#include <stdio.h>    // always necessary
#include <time.h>     // for time()



int dtrsm_(char *, char *, char *, char *, int *, int *,
	   double *, double *, int *, double *, int *);


int main(int argc, char *argv[] )
{
   int i, j, k;
   int m, n;
   double *M, *y;  
   double ctime;

   if(argc < 3) { printf(" Two arguments needed!\n"); return(-1); }
   if(argc == 3) {
      m = atoi(argv[1]);
      n = atoi(argv[2]);
   }


   //printf(" size= %g\n", m*n * sizeof(double)/(1024*1024.0) );
   srand48( (unsigned)time((time_t *)NULL) ); 

      M = (double *) malloc( m*m * sizeof(double) );
      y = (double *) malloc( m*n * sizeof(double) );   


      // MATRIX INIT
      for( j=0; j<m; j++ )
	 for( i=0; i<m; i++ ){
	    //printf( "index=%d\n", i+j*m );
	    //M[i+j*m] = 1.0 * i*n+j +1;  
	    M[i+j*m] = drand48();  
	 }
      

      // VECTOR INIT
      for( j=0; j<n; j++ )
	 for( i=0; i<m; i++ )
	    {
	       y[j*m+i] = 0.0;  
	       for(k=0;k<=i;k++) y[j*m+i]+=(j+1)*M[i+k*m];
	    }
      

      // Print Before
      for( i=0; i<m; i++ ){
	 for( j=0; j<m; j++ )
	    printf("M(%d,%d)=%.5g;\t", i+1, j+1, M[i+j*m] );	 
 	 printf("\n");
      }

      for( i=0; i<m; i++ ){
	 for( j=0; j<n; j++ )
	    printf("Y(%d,%d)=%.5g;\t", i+1, j+1, y[i+j*m] );	 
	 printf("\n");
      }
      

      double alpha = 1.0;
      int ldM = m;
      int ldy = m;
      //      char side = 'L';
      
      ctime = ((double) clock ())/CLOCKS_PER_SEC;

      dtrsm_( "L", "L", "N", "N", &m, &n, &alpha, &M[0], &ldM, y, &ldy );

      printf(" %d x %d:   ctime= %.5g;\n", m, n, 
	     (((double) clock ())/CLOCKS_PER_SEC) - ctime);


     // Print After
      for( i=0; i<m; i++ ){
	 for( j=0; j<n; j++ )
	    printf("Y(%d,%d)=%5.3g;\t", i+1, j+1, y[i+j*m] );	 
	 printf("\n");
      };


      free( M );
      free( y );


   return( 0 );
}

