// gcc -o trsv.x -Wall -L/Users/pauldj/works-G/libsG/OpenBLAS/ -lopenblas my-trsv.c


#include <stdlib.h>
#include <stdio.h> 


int dtrsv_( char *, char *, char *, int *, double *, int *, double *, int * );



int main( int argc, char *argv[] )
{
  int n, i, j;
  double *L, *y;
   
  if(argc == 1) printf(" argument needed: pass me one argument\n");
  if(argc > 1)  n = atoi(argv[1]);

  L = (double *) malloc( n * n * sizeof(double) );
  //  x = (double *) malloc( n * sizeof(double) );
  y = (double *) malloc( n * sizeof(double) );

  for( j=0; j<n; j++ )    //column
     for( i=0; i<n; i++ ) //row
	//printf( " counter 1: %d\t\tcounter 2: %d\n ", i + 10*j, 10*i + j );
	if( j <= i )
	   L[ i + j*n ] = 10*i + j + 2;
	else
	   L[ i + j*n ] = 0;

  for( i=0; i<n; i++ ) y[ i ] = 1; 


  FILE *output;
  output = fopen("mfile.m", "w");
  //output = stdout;

  fprintf(output, "L = [ ...\n" );
  for( i=0; i<n; i++ ) //row
    {
      for( j=0; j<n; j++ )  //column
	fprintf(output, "%g ", L[i+j*n] );
      fprintf(output, "; ...\n" );
    }
  fprintf(output, "];\n" );


  fprintf(output, "y = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%g; ...\n ", y[j] );
  fprintf(output, "];\n" );

  //  fprintf( output, " L \\ y \n" );

  
  char uplo = 'L';
  char trans = 'N';
  int incy = 1;

  dtrsv_( &uplo, &trans, "N", &n, L, &n, y, &incy );


  fprintf(output, "x = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%.16g; ...\n ", y[j] );
  fprintf(output, "];\n" );


  fprintf( output, " norm( L * x - y )\n" );



   return( 0 );
}

